#!/usr/bin/python
# -*- coding: utf-8 -*-
import os, sys
from RPLCD.i2c import CharLCD
import requests
import xml.etree.ElementTree as ET
import time

import socket
from datetime import datetime

LCD_WIDTH = 20
sURL = 'http://localhost:52199/MCWS/v1/Playback/Info?Zone=-1'
sUsername = 'user'
sPassword = 'password'

debug = 1
			
mylcd = CharLCD('PCF8574', 0x27,charmap='A00')	   								# create lcd object	

def readattrval(roota,branch):
	for child in roota.findall(branch):
		if debug == 1:
			print( child.attrib, child.text)
		return child.text

def geturl(url):
	#If you need credetials to access the media network use this line
	r = requests.get(url, auth=(sUsername, sPassword))
	#If you don't need credentials, use this line
	#r = requests.get(url)
	root = ET.fromstring(r.content)
	
	global PositionDisplay 
	PositionDisplay = readattrval(root,"./Item[@Name='PositionDisplay']")
	global Bitrate 
	Bitrate = readattrval(root,"./Item[@Name='Bitrate']")
	global Bitdepth 
	Bitdepth = readattrval(root,"./Item[@Name='Bitdepth']")
	global SampleRate
	SampleRate = readattrval(root,"./Item[@Name='SampleRate']")
	global Artist
	Artist = readattrval(root,"./Item[@Name='Artist']")
	global Album
	Album = readattrval(root,"./Item[@Name='Album']")
	global Name
	Name = readattrval(root,"./Item[@Name='Name']")
	global Status
	Status = readattrval(root,"./Item[@Name='Status']")
#	ZoneID,State,FileKey,NextFileKey,PositionMS,DurationMS
#	ElapsedTimeDisplay,RemainingTimeDisplay,TotalTimeDisplay,PlayingNowPosition
#	PlayingNowTracks,PlayingNowPositionDisplay,PlayingNowChangeCounter
#	Channels,Chapter,Volume,VolumeDisplay,ImageURL
while True:
	geturl(sURL)

	if Status == 'Playing':
		Artiststart = Artist
		Namestart = Name
		
		if len(Artist) > 20 or len(Name) > 21:
		
			str_pad = " " * 20
			if len(Artist) > len(Name):
				Artist = Artist.ljust(len(Name))
			else:
				Name = Name.ljust(len(Artist))

			my_long_string = str_pad + Artist
			my_long_string2 = str_pad + Name
		
			for i in range (0, len(my_long_string)):
				geturl(sURL)
				if Status == 'Playing' and Artist == Artiststart and Name == Namestart:
					lcd_text = my_long_string[i:(i+20)]
					lcd_text2 = my_long_string2[i:(i+20)]
					mylcd.cursor_pos = (0, 0)
					mylcd.write_string(lcd_text)
					mylcd.cursor_pos = (1, 0)
					mylcd.write_string(lcd_text2)
					mylcd.cursor_pos = (2, 0)
					mylcd.write_string(PositionDisplay.center(LCD_WIDTH," "))
					SampleRate = float(SampleRate) / 1000
					mylcd.cursor_pos = (3, 0)
					mylcd.write_string((str(SampleRate)  + "k|" + Bitdepth + "b|" + Bitrate + "kbps").center(LCD_WIDTH," "))
					time.sleep(0.4)
					mylcd.cursor_pos = (0, 0)
					mylcd.write_string(str_pad)
					mylcd.cursor_pos = (1, 0)
					mylcd.write_string(str_pad)
		else:
			mylcd.cursor_pos = (0, 0)
			mylcd.write_string(Artist[:LCD_WIDTH].center(LCD_WIDTH," "))
			mylcd.cursor_pos = (1, 0)
			mylcd.write_string(Name[:LCD_WIDTH].center(LCD_WIDTH," "))
			mylcd.cursor_pos = (2, 0)
			mylcd.write_string(PositionDisplay.center(LCD_WIDTH," "))
			SampleRate = float(SampleRate) / 1000
			mylcd.cursor_pos = (3, 0)
			mylcd.write_string((str(SampleRate)  + "k|" + Bitdepth + "b|" + Bitrate + "kbps").center(LCD_WIDTH," "))
					
	elif Status == 'Waiting' or Status == 'Buffering...' or Status == 'Opening...' or Status == 'Aborting, Please wait' or Status == 'Paused':
		mylcd.cursor_pos = (0, 0)
		mylcd.write_string(socket.gethostname().upper().center(LCD_WIDTH," "))
		mylcd.cursor_pos = (1, 0)
		mylcd.write_string("                    ")
		mylcd.cursor_pos = (2, 0)
		mylcd.write_string("                    ")
		if Status == 'Aborting, Please wait':
			mylcd.cursor_pos = (3, 0)
			mylcd.write_string(("Aborting...").center(LCD_WIDTH," "))
		else:
			mylcd.cursor_pos = (3, 0)
			mylcd.write_string(Status.center(LCD_WIDTH," "))
		time.sleep(2)
		
	else:
		mylcd.cursor_pos = (0, 0)
		mylcd.write_string(socket.gethostname().upper().center(LCD_WIDTH," "))
		mylcd.cursor_pos = (1, 0)
		mylcd.write_string("                    ")
		mylcd.cursor_pos = (2, 0)
		mylcd.write_string("                    ")
		now = datetime.now()
		duration = now.strftime("%X")
		mylcd.cursor_pos = (3, 0)
		mylcd.write_string(duration.center(LCD_WIDTH," "))
		#time.sleep(0.5)
